'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RequestView = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var INIT = 0,
    START = 1,
    SUCCESS = 2,
    FAILURE = 3,
    ERROR = 4;
var _ref = [ArrayBuffer || Object, ArrayBufferView || Object, URLSearchParams || Object],
    ArrayBuffer = _ref[0],
    ArrayBufferView = _ref[1],
    URLSearchParams = _ref[2];

var Request = function (_React$Component) {
    (0, _inherits3.default)(Request, _React$Component);

    function Request(props) {
        (0, _classCallCheck3.default)(this, Request);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Request.__proto__ || (0, _getPrototypeOf2.default)(Request)).call(this, props));

        _this.onSuccess = function () {
            _this.props.onSuccess(_this.state.response);
        };

        _this.onFailure = function () {
            _this.props.onFailure(_this.state.response);
        };

        _this.onError = function () {
            _this.props.onError(_this.state.error);
        };

        _this.request = function () {
            var _this$props = _this.props,
                url = _this$props.url,
                method = _this$props.method,
                headers = _this$props.headers,
                params = _this$props.params,
                data = _this$props.data,
                timeout = _this$props.timeout,
                auth = _this$props.auth,
                responseType = _this$props.responseType,
                xsrfCookieName = _this$props.xsrfCookieName,
                xsrfHeaderName = _this$props.xsrfHeaderName;


            var config = {
                url: url, method: method, headers: headers, params: params,
                data: data, timeout: timeout, auth: auth, responseType: responseType,
                xsrfCookieName: xsrfCookieName, xsrfHeaderName: xsrfHeaderName
            };

            // remove the undefined keys
            (0, _keys2.default)(config).map(function (k) {
                return config[k] === undefined ? delete config[k] : false;
            });

            _this.setState({ status: START }, _this.props.onStart);
            _axios2.default.request(config).then(function (response) {
                var code = Math.round(response.status / 100);
                switch (code) {
                    case 2:
                        _this.setState({ status: SUCCESS, response: response }, _this.props.onSuccess ? _this.onSuccess : undefined);
                        break;
                    default:
                        _this.setState({ status: FAILURE, response: response }, _this.props.onFailure ? _this.onFailure : undefined);
                }
            }).catch(function (err) {
                _this.setState({ status: ERROR, error: err }, _this.props.onError ? _this.onError : undefined);
            });
        };

        _this.state = {
            status: INIT,
            response: null,
            error: null
        };
        return _this;
    }

    (0, _createClass3.default)(Request, [{
        key: 'render',
        value: function render() {
            var render = [this.props.renderOnStart, this.props.renderOnSuccess, this.props.renderOnFailure, this.props.renderOnError][[START, SUCCESS, FAILURE, ERROR].indexOf(this.state.status)];
            return !render ? null : render();
        }

        /**
         * componentDidMount() is invoked immediately after a component is mounted.
         * Initialization that requires DOM nodes should go here.
         * If you need to load data from a remote endpoint,
         * this is a good place to instantiate the network request.
         * Setting state in this method will trigger a re-rendering.
         */

    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.request();
        }
    }]);
    return Request;
}(_react2.default.Component);

/*
 * See: https://github.com/mzabriskie/axios#request-config
 * More PropTypes will be added as & when required.
 */


Request.propTypes = {
    url: _react2.default.PropTypes.string.isRequired,

    // the http method is not required by axios &
    // defaults to 'get' if not provided
    method: _react2.default.PropTypes.oneOf(['get', 'post', 'put', 'patch', 'delete', 'head']),

    // `headers` are custom headers to be sent
    headers: _react2.default.PropTypes.object,

    // `params` are the URL parameters to be sent with the request
    // Must be a plain object or a URLSearchParams object
    params: _react2.default.PropTypes.object,

    // `data` is the data to be sent as the request body
    // Only applicable for request methods 'PUT', 'POST', and 'PATCH'
    // When no `transformRequest` is set, must be of one of the following types:
    // - string, plain object, ArrayBuffer, ArrayBufferView, URLSearchParams
    // - Browser only: FormData, File, Blob
    // - Node only: Stream
    data: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.object, _react2.default.PropTypes.instanceOf(ArrayBuffer), _react2.default.PropTypes.instanceOf(ArrayBufferView), _react2.default.PropTypes.instanceOf(URLSearchParams)]),

    // `timeout` specifies the number of milliseconds before the request times out.
    // If the request takes longer than `timeout`, the request will be aborted.
    timeout: _react2.default.PropTypes.number,

    // `auth` indicates that HTTP Basic auth should be used, and supplies credentials.
    // This will set an `Authorization` header, overwriting any existing
    // `Authorization` custom headers you have set using `headers`.
    // { username: 'janedoe', password: 's00pers3cret' }
    auth: _react2.default.PropTypes.object,

    // `responseType` indicates the type of data that the server will respond with
    // options are 'arraybuffer', 'blob', 'document', 'json', 'text', 'stream'
    // default: json
    responseType: _react2.default.PropTypes.oneOf(['arraybuffer', 'blob', 'document', 'json', 'text', 'stream']),

    // `xsrfCookieName` is the name of the cookie to use as a value for xsrf token
    // default: 'XSRF-TOKEN'
    xsrfCookieName: _react2.default.PropTypes.string,

    // `xsrfHeaderName` is the name of the http header that carries the xsrf token value
    // default: 'X-XSRF-TOKEN'
    xsrfHeaderName: _react2.default.PropTypes.string,

    /*
     * Props that behave either as hooks/callbacks,
     * these are the APIs provided by us.
     */
    onStart: _react2.default.PropTypes.func,
    onSuccess: _react2.default.PropTypes.func,
    onFailure: _react2.default.PropTypes.func,
    onError: _react2.default.PropTypes.func,

    renderOnStart: _react2.default.PropTypes.func,
    renderOnSuccess: _react2.default.PropTypes.func,
    renderOnFailure: _react2.default.PropTypes.func,
    renderOnError: _react2.default.PropTypes.func
};

exports.default = Request;

var RequestView = exports.RequestView = function (_Request) {
    (0, _inherits3.default)(RequestView, _Request);

    function RequestView() {
        (0, _classCallCheck3.default)(this, RequestView);
        return (0, _possibleConstructorReturn3.default)(this, (RequestView.__proto__ || (0, _getPrototypeOf2.default)(RequestView)).apply(this, arguments));
    }

    (0, _createClass3.default)(RequestView, [{
        key: 'render',
        value: function render() {
            var children = this.props.children;

            return _react2.default.cloneElement(_react2.default.Children.only(children), this.state);
        }
    }]);
    return RequestView;
}(Request);

var RequestViewStart = function (_React$Component2) {
    (0, _inherits3.default)(RequestViewStart, _React$Component2);

    function RequestViewStart() {
        (0, _classCallCheck3.default)(this, RequestViewStart);
        return (0, _possibleConstructorReturn3.default)(this, (RequestViewStart.__proto__ || (0, _getPrototypeOf2.default)(RequestViewStart)).apply(this, arguments));
    }

    (0, _createClass3.default)(RequestViewStart, [{
        key: 'render',
        value: function render() {
            if (this.props.status !== START) return null;
            return this.props.children;
        }
    }]);
    return RequestViewStart;
}(_react2.default.Component);

var RequestViewSuccess = function (_React$Component3) {
    (0, _inherits3.default)(RequestViewSuccess, _React$Component3);

    function RequestViewSuccess() {
        (0, _classCallCheck3.default)(this, RequestViewSuccess);
        return (0, _possibleConstructorReturn3.default)(this, (RequestViewSuccess.__proto__ || (0, _getPrototypeOf2.default)(RequestViewSuccess)).apply(this, arguments));
    }

    (0, _createClass3.default)(RequestViewSuccess, [{
        key: 'render',
        value: function render() {
            if (this.props.status !== SUCCESS) return null;
            return this.props.children;
        }
    }]);
    return RequestViewSuccess;
}(_react2.default.Component);

var RequestViewFailure = function (_React$Component4) {
    (0, _inherits3.default)(RequestViewFailure, _React$Component4);

    function RequestViewFailure() {
        (0, _classCallCheck3.default)(this, RequestViewFailure);
        return (0, _possibleConstructorReturn3.default)(this, (RequestViewFailure.__proto__ || (0, _getPrototypeOf2.default)(RequestViewFailure)).apply(this, arguments));
    }

    (0, _createClass3.default)(RequestViewFailure, [{
        key: 'render',
        value: function render() {
            if (this.props.status !== FAILURE) return null;
            return this.props.children;
        }
    }]);
    return RequestViewFailure;
}(_react2.default.Component);

var RequestViewError = function (_React$Component5) {
    (0, _inherits3.default)(RequestViewError, _React$Component5);

    function RequestViewError() {
        (0, _classCallCheck3.default)(this, RequestViewError);
        return (0, _possibleConstructorReturn3.default)(this, (RequestViewError.__proto__ || (0, _getPrototypeOf2.default)(RequestViewError)).apply(this, arguments));
    }

    (0, _createClass3.default)(RequestViewError, [{
        key: 'render',
        value: function render() {
            if (this.props.status !== ERROR) return null;
            return this.props.children;
        }
    }]);
    return RequestViewError;
}(_react2.default.Component);

RequestView.Start = RequestViewStart;
RequestView.Success = RequestViewSuccess;
RequestView.Failure = RequestViewFailure;
RequestView.Error = RequestViewError;